#!/usr/bin/perl

sub write_server {
    ($filename, $buffersize, $maxdataid, $framespeed, $numframes, $framesize) = @_;

    open SERVERFILE, $filename;

    print SERVERFILE "SRP_BUFFER_SIZE=$buffersize\n";
    print SERVERFILE "SRP_MAX_DATA_ID=$maxdataid\n";
    print SERVERFILE "FRAME_SPEED=$framespeed\n";
    print SERVERFILE "NUM_FRAMES=$numframes\n";
    print SERVERFILE "FRAME_SIZE=$framesize";

    close SERVERFILE;

}

sub write_trafclient {
    ($filename, $servproto, $servhost, $servport, $sleep, $outputfile) = @_;

    open CLIENTFILE, $filename;

    print CLIENTFILE "protocol=$servproto\n";
    print CLIENTFILE "host=$servhost\n";
    print CLIENTFILE "port=$servport\n";
    print CLIENTFILE "sleep=$sleep\n";
    print CLIENTFILE "outputfile=$outputfile";

    close CLIENTFILE;

}

sub write_client {
    ($filename, $buffersize, $maxdataid, $framespeed, $numretries, $rto) = @_;

    open CLIENTFILE, $filename;

    print CLIENTFILE "SRP_BUFFER_SIZE=$buffersize\n";
    print CLIENTFILE "SRP_MAX_DATA_ID=$maxdataid\n";
    print CLIENTFILE "FRAME_SPEED=$framespeed\n";
    print CLIENTFILE "SRP_NUM_RETRIES=$numretries\n";
    print CLIENTFILE "SRP_RTO=$rto";

    close CLIENTFILE;

}

$servermachine = "kaon";
$clientmachine = "muon";

$testdirectory = "/srp/testdir";

@audio = (1280, 160000);
@mpeg1 = (7300, 37000);
@mpeg2 = (34000, 37000);

$numframes = 100;
$clientbuffersize = 10;
$serverbuffersize = 10;
$maxdataid=255;
$numretries = 5;
$rto = 500000;
$framespeed = 1;

$trafproto="tcp";
$trafserver="gluon";
$trafport=1999;
$trafspeed=0;
$trafout="client";


@movefiles = ("$testdirectory/client_params.txt",
	      "$testdirectory/server_params.txt",
	      "$testdirectory/client_stats.txt",
	      "$testdirectory/server_stats.txt",
	      "$testdirectory/RecvTime.dat",
              "$testdirectory/client1_tcp_r.out",
              "$testdirectory/client1_tcp_s.out",
              "$testdirectory/client1_udp_r.out",
              "$testdirectory/client1_udp_s.out",
              "$testdirectory/client2_tcp_r.out",
              "$testdirectory/client2_tcp_s.out",
              "$testdirectory/client2_udp_r.out",
              "$testdirectory/client2_udp_s.out",
	      "$testdirectory/client3_tcp_r.out",
              "$testdirectory/client3_tcp_s.out",
              "$testdirectory/client3_udp_r.out",
              "$testdirectory/client3_udp_s.out");

# Audio tests


for ($testnum=1;$testnum<=1;$testnum++) {


    &write_server(">$testdirectory/server_params.txt", $serverbuffersize, $maxdataid, $audio[1], $numframes, $audio[0]); 

    &write_client(">$testdirectory/client_params.txt", $clientbuffersize, $maxdataid, 1, $testnum, $rto); 

    &write_trafclient(">$testdirectory/client1.in", $trafproto, $trafserver, 1997, $trafspeed, client1); 
    &write_trafclient(">$testdirectory/client2.in", $trafproto, $trafserver, 1998, $trafspeed, client2); 
    &write_trafclient(">$testdirectory/client3.in", $trafproto, $trafserver, 1999, $trafspeed, client3); 


    system ("./sendfile.exp", $servermachine, "server_params.txt");
    system ("./sendfile.exp", $clientmachine, "client_params.txt");
 

    system "./starttest.exp";
    print "$!";

    system ("./getfile.exp", $servermachine, "server_stats.txt", $testdirectory);
    system ("./getfile.exp", $clientmachine, "client_stats.txt", $testdirectory);
    system ("./getfile.exp", $clientmachine, "RecvTime.dat", $testdirectory);



    system ("mkdir", "$testdirectory/test$testnum");
    system ("mv", @movefiles, "$testdirectory/test$testnum");
    

}




