// SRP Client Helper for JAVA
// help_srp_client.c
// Created: 12/7/99
// Modified: 12/7/99

// 12-7  mpiecuch     Initial Creation 

// Compile: gcc srpserver.c


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include "../srpclientlib.c"

void lookup_addr(char *, int, char *, struct sockaddr_in *);

struct sockaddr_in addr;


int main(int argc, char **argv) {
  // Testing main function
  int udpsockno;
  int srpsock;
  int i;
  char test_data[255];


  udpsockno = helper_setup_udp_client_socket("gluon", 55555);
  srpsock = helper_start_srp_client(udpsockno);
  
  for (i=0;i<20;i++) {
    sprintf(test_data, "Test Data: %d", i);
    printf("Recieving %d\n", i);
    helper_recv_srp_client(srpsock, test_data, 255);
    printf("%s", test_data);
    sleep(10);
  }
  helper_stop_client_srp(srpsock);

}

int helper_setup_udp_client_socket (char *host, int port) {

  int udp_sock;
  int size_localaddr;
  struct srp_nack_packet srp_nack;


  lookup_addr(host, port, "udp", &addr);
      
  if ((udp_sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {perror("Socket Error! "); return(-1);}


  size_localaddr = sizeof(struct sockaddr_in);


  // Send a message to get the sample test server going
  srp_nack.status = SRP_STATUS_MISSING;
  srp_nack.srp_data_id = 1;
  sendto(udp_sock, &srp_nack, sizeof(struct srp_nack_packet), 0, &addr, sizeof(struct sockaddr_in));
 

  return(udp_sock);

}

int helper_start_srp_client (int udp_sock) {
 
  int size_localaddr;
  struct srp_nack_packet srp_nack;
  struct srp_client_socket *srp_sock;


  size_localaddr = sizeof(struct sockaddr_in);


  // Send a message to get the sample test server going
  srp_nack.status = SRP_STATUS_MISSING;
  srp_nack.srp_data_id = 1;
  sendto(udp_sock, &srp_nack, sizeof(struct srp_nack_packet), 0, &addr, sizeof(struct sockaddr_in));
 
  srp_sock = srp_client_start(udp_sock, 0, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));

  return((int) srp_sock);

}

int helper_recv_srp_client(int srp_sock, char buffer[], int size) {
  struct srp_client_socket *p_srp_sock;
  int bytes_read;

  p_srp_sock = (struct srp_client_socket *) srp_sock;
  srp_recvfrom(p_srp_sock, buffer, size);
  return(bytes_read);

}



int helper_stop_client_srp(int srpsock) {

  struct srp_client_socket *p_srp_sock;
  int retval;

  p_srp_sock = (struct srp_client_socket *) srpsock;

  retval = (int) p_srp_sock;

  return(retval);

}

void lookup_addr(char *name, int port, char *proto, struct sockaddr_in *sin) {

  struct hostent *addr_info;
  struct servent *port_info;
  char *pAddr, **ppAddr;
  struct in_addr addr;


  if ((addr_info = gethostbyname(name)) == NULL) {perror("Could not get addr! "); exit(1); }
  //  if ((port_info = getservbyport(htons(port), "udp")) == NULL) {perror("Could not get port! "); exit(1); }

  ppAddr = addr_info->h_addr_list;
  pAddr = ppAddr[0];

  memcpy(&addr, pAddr, sizeof(struct in_addr));

  sin->sin_addr = addr;
  sin->sin_family = AF_INET;
  sin->sin_port = htons(port);
  //  sin->sin_port = port_info->s_port;

}
