// Sample client to test server with


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>


// srp.h info

#define SRP_BUFFER_SIZE 10
#define SRP_MAX_DATA_ID 255
#define SRP_MAX_DATA_SIZE 1480
#define SRP_STATUS_MISSING 0

struct srp_data_packet {
  unsigned int srp_data_id;
  unsigned int srp_data_size;
  char data[SRP_MAX_DATA_SIZE];
};

struct srp_nack_packet {
  char status;
  unsigned int srp_data_id;
};


#define cchMax 256      /* max character buffer */
#define fdIn 0
#define fdOut 1

void lookup_addr(char *, int, char *, struct sockaddr_in *);

int main(int argc, char **argv) {

  struct sockaddr_in addr, peeraddr;
  int socketnum, socketnum2;
  char message[20];
  char buffer[255], *ClientCmd, *service, *uid;
  struct srp_nack_packet srp_nack;
  struct srp_data_packet srp_in_pkt;
  int size_localaddr;
  int retran_frame;


  if (argc != 3) {
    printf("Usage:  client <host> <port>\n");
    exit(1);
  } 

  // get ip address and port using command line args
  lookup_addr(argv[1], atoi(argv[2]), "udp", &addr);

  // setup and connect to address in above line
  if ((socketnum = make_sock(addr, SOCK_DGRAM)) == -1) {exit(1);}
 
  size_localaddr = sizeof(struct sockaddr_in);
 
  do {
    printf("retransmit # (0 for none)? ");
    scanf("%d", &retran_frame);
    if (retran_frame != 0) {
      srp_nack.status = SRP_STATUS_MISSING;
      srp_nack.srp_data_id = retran_frame;
      printf("Sending: %d\n", retran_frame);
      sendto(socketnum, &srp_nack, sizeof(struct srp_nack_packet), 0, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));
    }
    recvfrom(socketnum, &srp_in_pkt, sizeof(struct srp_data_packet), 0, (struct sockaddr *) &peeraddr, &size_localaddr);
    printf("%s: data_id: %d data: %s\n", inet_ntoa(peeraddr.sin_addr), srp_in_pkt.srp_data_id, srp_in_pkt.data);
  } while (1);




  close(socketnum);

  exit(0);

}



void lookup_addr(char *name, int port, char *proto, struct sockaddr_in *sin) {

  struct hostent *addr_info;
  struct servent *port_info;
  char *pAddr, **ppAddr;
  struct in_addr addr;


  if ((addr_info = gethostbyname(name)) == NULL) {perror("Could not get addr! "); exit(1); }
  //  if ((port_info = getservbyport(htons(port), "udp")) == NULL) {perror("Could not get port! "); exit(1); }

  ppAddr = addr_info->h_addr_list;
  pAddr = ppAddr[0];

  memcpy(&addr, pAddr, sizeof(struct in_addr));

  sin->sin_addr = addr;
  sin->sin_family = AF_INET;
  sin->sin_port = htons(port);
  //  sin->sin_port = port_info->s_port;

}


int make_sock(struct sockaddr_in sin, int proto) {
  int socketnum;

  if ((socketnum = socket(AF_INET, proto, 0)) < 0) {perror("Socket Error! "); return(-1);}
  if (connect(socketnum, (struct sockaddr *) &sin, sizeof(sin))) {perror("Connect error! "); return(-1);}


  return(socketnum);

}


