// Implements a client
import java.io.*;
import java.net.*;
import java.util.*;

public class ClientTCPReceiveThread extends Thread {
  
  long packets_in = 0;
  long bytes_in = 0;
  long delay = 0;

  private RandomAccessFile file = null;

  Socket socket;
  InetAddress address;
  int port;
  ClientBuffer cBuffer;

  public ClientTCPReceiveThread(Socket socket,
				InetAddress address, 
				int port, 
				ClientBuffer cBuffer,
				String outputfile) throws IOException {
    super("ClientTCPReceiveThread");
    this.socket = socket;
    this.address = address;
    this.port = port;
    this.cBuffer = cBuffer;
    
    file = new RandomAccessFile(new File(outputfile+"_tcp_r.out"), "rw");
  }
  
  public void run() {
    
    boolean toReceive = true;
    
    byte[] buf = new byte[256];
    byte[] Btime = new byte[12];
    byte[] Bid = new byte[8];
    long time_in;
    long packet_time;
    int packet_id;
    InputStream in = null;
    OutputStream out = null;

    try{
      in = socket.getInputStream();
      out = socket.getOutputStream();
    }catch(IOException e) {
      System.out.println("Recv: Unable to get input/output streams: " + e.getMessage());
//      socket.close();
      return;
    }
    
    while(toReceive) {
      
      try {
	// receive packet
	if (in.read(buf) == -1) {
	  System.out.println("End of File");
	}else{
	  
	  time_in = (new Date()).getTime();
	  
	  for (int i = 0; i < 12; i++){
	    Btime[i] = buf[i+8];
	  }
	  for (int i = 0; i < 8; i++){
	    Bid[i] = buf[i];
	  }
	  
	  packet_id = Integer.parseInt(new String(Bid));
	  packet_time = Long.parseLong(new String(Btime));
//     	System.out.println("time: " + packet_time);
	
	  delay += (time_in - packet_time);
	  
	  
//	if (cBuffer.getLog(packet_id, packet_time))
//	  System.out.println("removed: " +packet_id+":"+packet_time);
//	else
//	  System.out.println("unable to remove: " +packet_id+":"+packet_time);

	  packets_in++;
	  bytes_in += buf.length;
	  outputfile();
	}
      }catch(Exception e) {
	System.out.println("Unable to receive: " + e.getMessage());
	//	toReceive = false;
      }
    }
  }
  
  private void outputfile() {
    try{
      file.seek(0L);
      file.writeBytes("Bytes received: " + bytes_in + 
		      "\nPackets received: " + packets_in);
    }catch (IOException e){
      System.out.println("Unable to write to output file");
    }
  }
  
  public void output(){
    System.out.println("Received " + bytes_in + 
		       " bytes in " + packets_in + 
		       " packets");
    System.out.println("Avg. Delay: " + (delay/packets_in));
  }
  
}


