import java.io.*;
import java.net.*;
import java.util.*;

public class TCPThread extends Thread {

  protected Socket socket = null;
  protected ServerSocket s_socket = null;
  protected BufferedReader in = null;
  protected boolean moreTraffic = true;
  private RandomAccessFile file = null;

  public long bytes_in = 0;
  public long packets_in = 0;

  public TCPThread(int port, String filename) throws IOException {
    super("TCPThread");
    s_socket = new ServerSocket(port);
    
    System.out.println("Server: Created TCP socket on port " +port);
        
    file = new RandomAccessFile(new File(filename), "rw");
  }


  public void run() {
    boolean moreTraffic = true;
    
    byte[] Btime = new byte[12];
    byte[] Bid = new byte[8];
    long packet_time;
    int packet_id;
    Random send = new Random();
    InputStream in = null;
    OutputStream out = null;


    try{
      System.out.println("Waiting for connection");
      socket = s_socket.accept();
      System.out.println("Accepted connection");
      in = socket.getInputStream();
      out = socket.getOutputStream();
    }catch(IOException e) {
      System.out.println("Unable to get input/output streams: " + e.getMessage());
//      socket.close();
      return;
    }
    
    while (moreTraffic) {
      try {
	byte[] buf = new byte[256];
	
	if (in.read(buf) == -1) {
	  System.out.println("End of File");
	  return;
	}else{
	  // read stuff into buffer
	  packets_in++;
//	  bytes_in += buf.length;
	  bytes_in += 256;
	  outputfile();
	  
	  for (int i=0; i < 12; i++){
	    Btime[i] = buf[i+8];
	  }
	  for (int i=0; i < 8; i++){
	    Bid[i] = buf[i];
	  }
	  
	  packet_id = Integer.parseInt(new String(Bid));
	  packet_time = Long.parseLong(new String(Btime));
	  
	  // send the response to the client
//	if ((Math.abs(send.nextInt())%2) == 1){
	  System.out.println("sent: "+packet_id + ":" + packet_time);
	  out.write(buf);
	  out.flush();
//	}else{
//	  System.out.println("dropped: "+packet_id + ":" + packet_time);
//	}
//	sleep(10000);
	}
      } catch (Exception e) {
	e.printStackTrace();
	moreTraffic = false;
      }
      
    }
    try{
      socket.close();
    }catch(IOException e){
      System.out.println("Unable to close socket: " + e.getMessage());
    }
  }


  private void outputfile() {
    try{
      file.seek(0L);
      file.writeBytes("Bytes Received: " + bytes_in);
//      "\nPackets Received: " + packets_in);
    }catch (IOException e){
      System.out.println("Unable to write to output file");
    }
  }
  
  public void output() {
    System.out.println("Bytes Received: " + bytes_in +
      "\nPackets Received: " + packets_in);
  }
  
}
