import java.io.*;
import java.net.*;
import java.util.*;

public class UDPThread extends Thread {

  protected DatagramSocket socket = null;
  protected BufferedReader in = null;
  
  private RandomAccessFile file = null;

  public long packets_in = 0;
  public long bytes_in = 0;

  public UDPThread(int port, String filename) throws IOException {
    super("UDPThread");
    socket = new DatagramSocket(port);
//    FileDescriptor fd = socket.getFileDescriptor();
    System.out.println("Server: Created UDP socket on port " +port);

    
    file = new RandomAccessFile(new File(filename), "rw");
  }
  
  public void run() {
    boolean moreTraffic = true;
    
//      System.out.println("Socket Timeout: " + socket.getSoTimeout() + 
//  		       "\nSend Buffer size: " + socket.getSendBufferSize() + 
//  		       "\nReceive Buffer Size: " + socket.getReceiveBufferSize());
    
    byte[] Btime = new byte[12];
    byte[] Bid = new byte[8];
    long packet_time;
    int packet_id;
    
    Random send = new Random();
    
    while (moreTraffic) {
      try {
	byte[] buf = new byte[256];
	
	// receive request
	DatagramPacket rPacket = new DatagramPacket(buf, buf.length);
	socket.receive(rPacket);
	// once packet is received, need to send it back to client
	
	packets_in++;
	bytes_in += rPacket.getLength();
	outputfile();
	
	
	buf = rPacket.getData();
	for (int i=0; i < 12; i++){
//	  System.out.print(buf[i]);
	  Btime[i] = buf[i+8];
	}
	for (int i=0; i < 8; i++){
	  Bid[i] = buf[i];
	}

	packet_id = Integer.parseInt(new String(Bid));
	packet_time = Long.parseLong(new String(Btime));

	// send the response to the client
//	if ((Math.abs(send.nextInt())%2) == 1){
//	  System.out.println("sent: "+packet_id + ":" + packet_time);
	  socket.send(rPacket);
//	}else{
//	  System.out.println("dropped: "+packet_id + ":" + packet_time);
//	}
//	sleep(10000);

      } catch (Exception e) {
	e.printStackTrace();
	moreTraffic = false;
      }
    }
    socket.close();
  }
  
  private void outputfile() {
    try{
      file.seek(0L);
      file.writeBytes("Bytes Received: " + bytes_in + 
		      "\nPackets Received: " + packets_in);
    }catch (IOException e){
      System.out.println("Unable to write to output file");
    }
  }
  
  public void output() {
    System.out.println("Bytes Received: " + bytes_in + 
		       "\nPackets Received: " + packets_in);
  }
  
}
